// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import com.aliyun.tea.*;
import com.aliyun.ecs20140526.*;
import com.aliyun.ecs20140526.models.*;
import com.aliyun.teaopenapi.*;
import com.aliyun.teaopenapi.models.*;
import com.aliyun.teaconsole.*;
import com.aliyun.darabonba.env.*;
import com.aliyun.teautil.*;

public class Sample {

    /**
    * Initialization  初始化公共请求参数
    */
    public static com.aliyun.ecs20140526.Client Initialization(String regionId) throws Exception {
        Config config = new Config();
        // 您的AccessKey ID
        config.accessKeyId = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_ID");
        // 您的AccessKey Secret
        config.accessKeySecret = com.aliyun.darabonba.env.EnvClient.getEnv("ACCESS_KEY_SECRET");
        // 您的可用区ID
        config.regionId = regionId;
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static void RenewJob(com.aliyun.ecs20140526.Client client, String regionId, Integer pageSize, Integer pageNumber, Boolean checkNeedRenew, String securityGroupId) throws Exception {
        DescribeInstancesResponse response = Sample.DescribeNeedRenewInstance(client, regionId, pageSize, pageNumber, null, checkNeedRenew, securityGroupId);
        java.util.List<DescribeInstancesResponseBody.DescribeInstancesResponseBodyInstancesInstance> instances = response.body.instances.instance;
        if (com.aliyun.teautil.Common.isUnset(TeaModel.buildMap(response.body.instances))) {
            com.aliyun.teaconsole.Client.log("no instances need to renew.");
            return ;
        }

        String instanceIds = null;
        if (com.aliyun.teautil.Common.equalNumber(response.body.totalCount, 0)) {
            return ;
        }

        com.aliyun.teaconsole.Client.log("" + response.body.totalCount + " instances need to renew.");
        for (DescribeInstancesResponseBody.DescribeInstancesResponseBodyInstancesInstance instance : instances) {
            String instanceId = instance.instanceId;
            if (com.aliyun.teautil.Common.isUnset(instanceIds)) {
                instanceIds = instanceId;
            } else {
                instanceIds = "" + instanceIds + "," + instanceId + "";
            }

            Sample.RenewInstance(client, regionId, instanceId, 1);
        }
        com.aliyun.teaconsole.Client.log("renew " + instanceIds + " ready.");
    }

    public static DescribeInstancesResponse DescribeNeedRenewInstance(com.aliyun.ecs20140526.Client client, String regionId, Integer pageSize, Integer pageNumber, String instanceId, Boolean checkNeedRenew, String securityGroupId) throws Exception {
        DescribeInstancesRequest request = new DescribeInstancesRequest()
                .setRegionId(regionId);
        if (!com.aliyun.teautil.Common.isUnset(instanceId)) {
            request.instanceIds = com.aliyun.teautil.Common.toJSONString(java.util.Arrays.asList(
                instanceId
            ));
        }

        if (!com.aliyun.teautil.Common.isUnset(securityGroupId)) {
            request.securityGroupId = securityGroupId;
        }

        if (com.aliyun.teautil.Common.isUnset(checkNeedRenew)) {
            checkNeedRenew = true;
        }

        if (checkNeedRenew) {
            DescribeInstancesRequest.DescribeInstancesRequestFilter filter1 = new DescribeInstancesRequest.DescribeInstancesRequestFilter();
            DescribeInstancesRequest.DescribeInstancesRequestFilter filter2 = new DescribeInstancesRequest.DescribeInstancesRequestFilter();
            DescribeInstancesRequest.DescribeInstancesRequestFilter filter3 = new DescribeInstancesRequest.DescribeInstancesRequestFilter()
                    .setKey("ExpiredStartTime")
                    .setValue("2024-09-01T00:00Z");
            DescribeInstancesRequest.DescribeInstancesRequestFilter filter4 = new DescribeInstancesRequest.DescribeInstancesRequestFilter()
                    .setKey("ExpiredEndTime")
                    .setValue("2024-10-01T00:00Z");
            request.filter = java.util.Arrays.asList(
                filter1,
                filter2,
                filter3,
                filter4
            );
        }

        if (com.aliyun.teautil.Common.isUnset(pageSize)) {
            pageSize = 100;
        }

        if (com.aliyun.teautil.Common.isUnset(pageNumber)) {
            pageNumber = 1;
        }

        request.pageSize = pageSize;
        request.pageNumber = pageNumber;
        DescribeInstancesResponse response = client.describeInstances(request);
        com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(response.body.instances.instance));
        return response;
    }

    public static void DescribeInstanceAutoRenewSetting(com.aliyun.ecs20140526.Client client, String regionId, String instanceIds, Boolean expectedAutoRenew) throws Exception {
        DescribeInstanceAutoRenewAttributeRequest request = new DescribeInstanceAutoRenewAttributeRequest()
                .setRegionId(regionId)
                .setInstanceId(instanceIds);
        DescribeInstanceAutoRenewAttributeResponse response = client.describeInstanceAutoRenewAttribute(request);
        String failedInstanceIds = null;
        if (com.aliyun.teautil.Common.isUnset(TeaModel.buildMap(response.body.instanceRenewAttributes))) {
            return ;
        }

        if (com.aliyun.teautil.Common.isUnset(expectedAutoRenew)) {
            expectedAutoRenew = true;
        }

        java.util.List<DescribeInstanceAutoRenewAttributeResponseBody.DescribeInstanceAutoRenewAttributeResponseBodyInstanceRenewAttributesInstanceRenewAttribute> instanceRenewAttributes = response.body.instanceRenewAttributes.instanceRenewAttribute;
        for (DescribeInstanceAutoRenewAttributeResponseBody.DescribeInstanceAutoRenewAttributeResponseBodyInstanceRenewAttributesInstanceRenewAttribute instanceRenewAttribute : instanceRenewAttributes) {
            String instanceId = instanceRenewAttribute.instanceId;
            Boolean autoRenewStatus = instanceRenewAttribute.autoRenewEnabled;
            if (!autoRenewStatus && expectedAutoRenew || autoRenewStatus && !expectedAutoRenew) {
                if (com.aliyun.teautil.Common.isUnset(failedInstanceIds)) {
                    failedInstanceIds = instanceId;
                } else {
                    failedInstanceIds = "" + failedInstanceIds + "," + instanceId + "";
                }

            }

        }
        if (!com.aliyun.teautil.Common.isUnset(failedInstanceIds)) {
            com.aliyun.teaconsole.Client.log("instance " + failedInstanceIds + " auto renew not match expect " + expectedAutoRenew + ".");
        }

    }

    public static void SettingInstanceAutoRenew(com.aliyun.ecs20140526.Client client, String regionId, String instanceIds, Boolean autoRenew) throws Exception {
        if (com.aliyun.teautil.Common.isUnset(autoRenew)) {
            autoRenew = true;
        }

        com.aliyun.teaconsole.Client.log("execute enable auto renew " + instanceIds + "");
        ModifyInstanceAutoRenewAttributeRequest request = new ModifyInstanceAutoRenewAttributeRequest()
                .setRegionId(regionId)
                .setInstanceId(instanceIds)
                .setDuration(1)
                .setAutoRenew(autoRenew);
        client.modifyInstanceAutoRenewAttribute(request);
        Sample.DescribeInstanceAutoRenewSetting(client, regionId, instanceIds, autoRenew);
    }

    public static Boolean CheckInstanceNeedRenew(com.aliyun.ecs20140526.Client client, String regionId, String instanceId) throws Exception {
        DescribeInstancesResponse response = Sample.DescribeNeedRenewInstance(client, regionId, null, null, instanceId, null, null);
        if (com.aliyun.teautil.Common.equalNumber(response.body.totalCount, 1)) {
            return true;
        }

        return false;
    }

    public static void RenewInstance(com.aliyun.ecs20140526.Client client, String regionId, String instanceId, Integer period) throws Exception {
        Boolean needRenew = Sample.CheckInstanceNeedRenew(client, regionId, instanceId);
        if (!needRenew) {
            com.aliyun.teaconsole.Client.log("instance " + instanceId + " not need renew.");
            return ;
        }

        RenewInstanceRequest request = new RenewInstanceRequest()
                .setInstanceId(instanceId)
                .setPeriod(period);
        RenewInstanceResponse response = client.renewInstance(request);
        com.aliyun.teaconsole.Client.log("renew " + instanceId + " ready, output is " + com.aliyun.teautil.Common.toJSONString(TeaModel.buildMap(response)) + "");
    }

    public static void main(String[] args_) throws Exception {
        java.util.List<String> args = java.util.Arrays.asList(args_);
        com.aliyun.teaconsole.Client.log("Renew ECS Instance By OpenApi!");
        // 地域Id
        String regionId = args.get(0);
        com.aliyun.ecs20140526.Client client = Sample.Initialization(regionId);
        // 查询在指定的时间范围内是否有需要续费的实例
        Sample.DescribeNeedRenewInstance(client, regionId, null, null, null, null, null);
        // 续费实例，直接执行费用扣除
        // RenewInstance(client, regionId, "i-bp13o5257vcnw7vr****", 1);
        // 查询实例自动续费的状态
        // DescribeInstanceAutoRenewSetting(client, regionId, "i-bp13o5257vcnw7vr****", true);
        // 设置实例自动续费
        // SettingInstanceAutoRenew(client, regionId, "i-bp13o5257vcnw7vr****", true);
    }
}
